;;; -*- mode: lisp; syntax: common-lisp; base: 10; package: JSGEN -*-
;;
;; case-read.lisp -- #% reader macro for reading what follows as quoted,
;;                   case-preserved, and into :jsgen package.
;;
;; Copyright (c) 2006, Jason Kantz <jason@kantz.com>
;; All rights reserved.
;;
;;; Code:

(in-package :jsgen)


(defun preserve-case-dispatch (stream c n)
  (declare (ignore c))
  (let ((readtable-case (readtable-case *readtable*))
        (new-case (cond ((null n) :preserve)
                        ((= n 0) :preserve)
                        ((= n 1) :upcase)
                        (t :preserve))))
    (setf (readtable-case *readtable*) new-case)
    (prog1 (let ((*package* (find-package :jsgen)))
             `(quote ,(read stream t nil t)))
      (setf (readtable-case *readtable*) readtable-case))))

(defreadtable *preserve-case-readtable*
  (set-dispatch-macro-character #\# #\%
                                #'preserve-case-dispatch
                                *preserve-case-readtable*))


;;; case-read.lisp ends here